lib

# Class: ObjectClass

Source Location: /lib/schema.inc

### Class Overview

    SchemaItem
       |
       --ObjectClass

Represents an LDAP objectClass

### Variables

- $children_objectclasses
- $is_obsolete
- $may_attrs
- $must_attrs
- $name
- $sup_classes
- $type

### Methods

- ObjectClass
- addChildObjectClass
- addMayAttrs
- addMustAttrs
- getChildObjectClasses
- getIsObsolete
- getMayAttrNames
- getMayAttrs
- getMustAttrNames
- getMustAttrs
- getName
- getSupClasses
- getType
- initVars

### Inherited Variables

#### Class: SchemaItem

SchemaItem::$description
SchemaItem::$oid

### Inherited Methods

#### Class: SchemaItem

SchemaItem::SchemaItem()
  Default constructor.
SchemaItem::getDescription()
SchemaItem::getOID()
SchemaItem::initVars()
  Initialize class members to default values.
SchemaItem::setDescription()
SchemaItem::setOID()

### Class Details

[line 91]
Represents an LDAP objectClass
[ Top ]

### Class Variables

#### $children_objectclasses =

[line 106]

array of objectClasses which inherit from this one (must be set at runtime explicitly by the caller)

Type: | mixed

[ Top ]

#### $is_obsolete =

[line 104]

boolean value indicating whether this objectClass is obsolete

Type: | mixed

[ Top ]

#### $may_attrs =

[line 102]

arrays of attribute names that this objectClass allows, but does not require

Type: | mixed

[ Top ]

#### $must_attrs =

[line 100]

arrays of attribute names that this objectClass requires

Type: | mixed

[ Top ]

#### $name =

[line 94]

This objectClass' name, ie "inetOrgPerson"

Type: | mixed

[ Top ]

#### $sup_classes =

[line 96]

array of objectClass names from which this objectClass inherits

Type: | mixed

[ Top ]

#### $type =

[line 98]

one of STRUCTURAL, ABSTRACT, or AUXILIARY

Type: | mixed

[ Top ]

### Class Methods

### constructor ObjectClass [line 126]

`ObjectClass ObjectClass( $raw_ldap_schema_string)`

Creates a new ObjectClass object given a raw LDAP objectClass string.

#### Parameters:

| $raw_ldap_schema_string |

[ Top ]

### method addChildObjectClass [line 376]

`bool addChildObjectClass( String $object_class_name)`

Adds an objectClass to the list of objectClasses that inherit from this objectClass.

#### Tags:

return: | Returns true on success or false on failure (objectclass already existed for example)

#### Parameters:

String | $object_class_name | The name of the objectClass to add

[ Top ]

### method addMayAttrs [line 454]

`void addMayAttrs( array $new_may_attrs)`

Behaves identically to addMustAttrs, but it operates on the MAY attributes of this objectClass.

#### Parameters:

array | $new_may_attrs | An array of attribute names (strings) to add.

[ Top ]

### method addMustAttrs [line 439]

`void addMustAttrs( array $new_must_attrs)`

Adds the specified array of attributes to this objectClass' list of MUST attributes. The resulting array of must attributes will contain unique members.

#### Parameters:

array | $new_must_attrs | An array of attribute names (strings) to add.

[ Top ]

### method getChildObjectClasses [line 392]

`Array getChildObjectClasses( )`

Returns the array of objectClass names which inherit from this objectClass.

#### Tags:

return: | Names of objectClasses which inherit from this objectClass.

[ Top ]

### method getIsObsolete [line 427]

`void getIsObsolete( )`

Gets whether this objectClass is flagged as obsolete by the LDAP server.
[ Top ]

### method getMayAttrNames [line 361]

`array getMayAttrNames( [array $oclasses = null])`

Gets an array of attribute names (strings) that entries of this ObjectClass must define.

This differs from getMayAttrs in that it returns an array of strings rather than array of AttributeType objects

#### Tags:

return: | The array of allowed attribute names (strings).
see: | ObjectClass::getMustAttrNames()
see: | ObjectClass::getMayAttrs()
see: | ObjectClass::getMustAttrs()

#### Parameters:

array | $oclasses | An array of ObjectClass objects to use when traversing the inheritance tree. This presents some what of a bootstrapping problem as we must fetch all objectClasses to determine through inheritance which attributes this objectClass provides.

[ Top ]

### method getMayAttrs [line 303]

`array getMayAttrs( [array $oclasses = NULL])`

Gets an array of AttributeType objects that entries of this ObjectClass may define.

This differs from getMayAttrNames in that it returns an array of AttributeType objects

#### Tags:

return: | The array of allowed AttributeType objects.
see: | AttributeType
see: | ObjectClass::getMayAttrNames()
see: | ObjectClass::getMustAttrs()
see: | ObjectClass::getMustAttrNames()

#### Parameters:

array | $oclasses | An array of ObjectClass objects to use when traversing the inheritance tree. This presents some what of a bootstrapping problem as we must fetch all objectClasses to determine through inheritance which attributes this objectClass provides.

[ Top ]

### method getMustAttrNames [line 337]

`array getMustAttrNames( [array $oclasses = null])`

Gets an array of attribute names (strings) that entries of this ObjectClass must define.

This differs from getMustAttrs in that it returns an array of strings rather than array of AttributeType objects

#### Tags:

return: | The array of allowed attribute names (strings).
see: | ObjectClass::getMayAttrNames()
see: | ObjectClass::getMayAttrs()
see: | ObjectClass::getMustAttrs()

#### Parameters:

array | $oclasses | An array of ObjectClass objects to use when traversing the inheritance tree. This presents some what of a bootstrapping problem as we must fetch all objectClasses to determine through inheritance which attributes this objectClass provides.

[ Top ]

### method getMustAttrs [line 269]

`array getMustAttrs( [array $oclasses = NULL])`

Gets an array of AttributeType objects that entries of this ObjectClass must define.

This differs from getMustAttrNames in that it returns an array of AttributeType objects

#### Tags:

return: | The array of required AttributeType objects.
see: | ObjectClass::getMayAttrNames()
see: | ObjectClass::getMayAttrs()
see: | ObjectClass::getMustAttrNames()

#### Parameters:

array | $oclasses | An array of ObjectClass objects to use when traversing the inheritance tree. This presents some what of a bootstrapping problem as we must fetch all objectClasses to determine through inheritance which attributes this objectClass requires.

[ Top ]

### method getName [line 401]

`string getName( )`

Gets the name of this objectClass (ie, "inetOrgPerson")

#### Tags:

return: | The name of the objectClass

[ Top ]

### method getSupClasses [line 411]

`array getSupClasses( )`

Gets the objectClass names from which this objectClass inherits.

#### Tags:

return: | An array of objectClass names (strings)

[ Top ]

### method getType [line 419]

`void getType( )`

Gets the type of this objectClass: STRUCTURAL, ABSTRACT, or AUXILIARY.
[ Top ]

### method initVars [line 109]

`void initVars( )`

Initialize the class' member variables
Overrides SchemaItem::initVars() (Initialize class members to default values.)
[ Top ]

Documentation generated on Thu, 28 Oct 2010 21:00:34 +0200 by phpDocumentor 1.4.1